<html>
<head>
<title>OgreLight.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreLight.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreLight_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _LIGHT_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _LIGHT_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreColourValue_8h.html">OgreColourValue.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector4_8h.html">OgreVector4.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreMovableObject_8h.html">OgreMovableObject.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgrePlaneBoundedVolume_8h.html">OgrePlaneBoundedVolume.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="OgreShadowCameraSetup_8h.html">OgreShadowCameraSetup.h</a>&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>Ogre {
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00072"></a><a class="code" href="classOgre_1_1Light.html">00072</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>
<a name="l00073"></a>00073     {
<a name="l00074"></a>00074     <span class="keyword">public</span>:
<a name="l00076"></a><a class="code" href="classOgre_1_1Light.html#ae3e2e4e50055bf99fd923ffa4f539f7d">00076</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Light.html#ae3e2e4e50055bf99fd923ffa4f539f7d" title="Temp tag used for sorting.">tempSquareDist</a>;
<a name="l00078"></a>00078         <span class="keywordtype">void</span> _calcTempSquareDist(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; worldPos);
<a name="l00079"></a>00079 
<a name="l00081"></a><a class="code" href="classOgre_1_1Light.html#a4f1dea084d1497c6f49e802ade940dbc">00081</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Light.html#a4f1dea084d1497c6f49e802ade940dbc" title="Defines the type of light.">LightTypes</a>
<a name="l00082"></a>00082         {
<a name="l00084"></a><a class="code" href="classOgre_1_1Light.html#a4f1dea084d1497c6f49e802ade940dbca0d59bfdcfeb338dbfe06e2e2999e752f">00084</a>             LT_POINT = 0,
<a name="l00086"></a><a class="code" href="classOgre_1_1Light.html#a4f1dea084d1497c6f49e802ade940dbca4c5582d28848ce40c2b652488494b4a3">00086</a>             LT_DIRECTIONAL = 1,
<a name="l00088"></a><a class="code" href="classOgre_1_1Light.html#a4f1dea084d1497c6f49e802ade940dbca8fc40a1ccfb026944417ef92b7ddaefe">00088</a>             LT_SPOTLIGHT = 2
<a name="l00089"></a>00089         };
<a name="l00090"></a>00090 
<a name="l00093"></a>00093         <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>();
<a name="l00094"></a>00094 
<a name="l00097"></a>00097         <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00098"></a>00098 
<a name="l00101"></a>00101         ~<a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>();
<a name="l00102"></a>00102 
<a name="l00105"></a>00105         <span class="keywordtype">void</span> setType(LightTypes type);
<a name="l00106"></a>00106 
<a name="l00109"></a>00109         LightTypes getType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00110"></a>00110 
<a name="l00120"></a>00120         <span class="keywordtype">void</span> setDiffuseColour(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> red, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> green, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> blue);
<a name="l00121"></a>00121 
<a name="l00131"></a>00131         <span class="keywordtype">void</span> setDiffuseColour(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour);
<a name="l00132"></a>00132 
<a name="l00135"></a>00135         <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; getDiffuseColour(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00136"></a>00136 
<a name="l00146"></a>00146         <span class="keywordtype">void</span> setSpecularColour(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> red, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> green, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> blue);
<a name="l00147"></a>00147 
<a name="l00157"></a>00157         <span class="keywordtype">void</span> setSpecularColour(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour);
<a name="l00158"></a>00158 
<a name="l00161"></a>00161         <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; getSpecularColour(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00162"></a>00162 
<a name="l00182"></a>00182         <span class="keywordtype">void</span> setAttenuation(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> range, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> constant, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linear, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> quadratic);
<a name="l00183"></a>00183 
<a name="l00186"></a>00186         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getAttenuationRange(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00187"></a>00187 
<a name="l00190"></a>00190         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getAttenuationConstant(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00191"></a>00191 
<a name="l00194"></a>00194         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getAttenuationLinear(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00195"></a>00195 
<a name="l00198"></a>00198         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getAttenuationQuadric(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00199"></a>00199 
<a name="l00206"></a>00206         <span class="keywordtype">void</span> setPosition(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z);
<a name="l00207"></a>00207 
<a name="l00214"></a>00214         <span class="keywordtype">void</span> setPosition(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec);
<a name="l00215"></a>00215 
<a name="l00220"></a>00220         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getPosition(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00221"></a>00221 
<a name="l00228"></a>00228         <span class="keywordtype">void</span> setDirection(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z);
<a name="l00229"></a>00229 
<a name="l00236"></a>00236         <span class="keywordtype">void</span> setDirection(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec);
<a name="l00237"></a>00237 
<a name="l00242"></a>00242         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getDirection(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00243"></a>00243 
<a name="l00254"></a>00254         <span class="keywordtype">void</span> setSpotlightRange(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; innerAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; outerAngle, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> falloff = 1.0);
<a name="l00255"></a>00255 
<a name="l00258"></a>00258         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; getSpotlightInnerAngle(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00259"></a>00259 
<a name="l00262"></a>00262         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; getSpotlightOuterAngle(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00263"></a>00263 
<a name="l00266"></a>00266         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSpotlightFalloff(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00267"></a>00267 
<a name="l00270"></a>00270         <span class="keywordtype">void</span> setSpotlightInnerAngle(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; val);
<a name="l00271"></a>00271 
<a name="l00274"></a>00274         <span class="keywordtype">void</span> setSpotlightOuterAngle(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; val);
<a name="l00275"></a>00275 
<a name="l00278"></a>00278         <span class="keywordtype">void</span> setSpotlightFalloff(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> val);
<a name="l00279"></a>00279 
<a name="l00285"></a><a class="code" href="classOgre_1_1Light.html#aead9fea5c5d5869387d88869d0132cad">00285</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Light.html#aead9fea5c5d5869387d88869d0132cad" title="Set the near clip plane distance to be used by spotlights that use light clipping, allowing you to render spots as if they start from further down their frustum.">setSpotlightNearClipDistance</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearClip) { mSpotNearClip = nearClip; }
<a name="l00286"></a>00286         
<a name="l00290"></a><a class="code" href="classOgre_1_1Light.html#a7e81aca482d2f2adcb0d7b2c884bb2bf">00290</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Light.html#a7e81aca482d2f2adcb0d7b2c884bb2bf" title="Get the near clip plane distance to be used by spotlights that use light clipping.">getSpotlightNearClipDistance</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSpotNearClip; }
<a name="l00291"></a>00291         
<a name="l00299"></a>00299         <span class="keywordtype">void</span> setPowerScale(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> power);
<a name="l00300"></a>00300 
<a name="l00304"></a>00304         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getPowerScale(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00305"></a>00305 
<a name="l00307"></a>00307         <span class="keywordtype">void</span> _notifyAttached(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* parent, <span class="keywordtype">bool</span> isTagPoint = <span class="keyword">false</span>);
<a name="l00308"></a>00308 
<a name="l00310"></a>00310         <span class="keywordtype">void</span> _notifyMoved(<span class="keywordtype">void</span>);
<a name="l00311"></a>00311 
<a name="l00313"></a>00313         <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getBoundingBox(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00314"></a>00314 
<a name="l00316"></a>00316         <span class="keywordtype">void</span> _updateRenderQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue);
<a name="l00317"></a>00317 
<a name="l00319"></a>00319         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMovableType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00320"></a>00320 
<a name="l00324"></a>00324         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getDerivedPosition(<span class="keywordtype">bool</span> cameraRelativeIfSet = <span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00325"></a>00325 
<a name="l00327"></a>00327         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getDerivedDirection(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00328"></a>00328 
<a name="l00334"></a>00334         <span class="keywordtype">void</span> setVisible(<span class="keywordtype">bool</span> visible);
<a name="l00335"></a>00335 
<a name="l00337"></a><a class="code" href="classOgre_1_1Light.html#ae7e7988aaa1cc5c7248241e7598d4ed4">00337</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Light.html#ae7e7988aaa1cc5c7248241e7598d4ed4" title="Overridden from MovableObject.">getBoundingRadius</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; <span class="comment">/* not visible */</span> }
<a name="l00338"></a>00338 
<a name="l00348"></a>00348         <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> getAs4DVector(<span class="keywordtype">bool</span> cameraRelativeIfSet = <span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00349"></a>00349 
<a name="l00359"></a>00359         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1PlaneBoundedVolume.html" title="Represents a convex volume bounded by planes.">PlaneBoundedVolume</a>&amp; _getNearClipVolume(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* <span class="keyword">const</span> cam) <span class="keyword">const</span>;
<a name="l00360"></a>00360 
<a name="l00367"></a>00367         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="group__Math.html#ga6253a1300d656ba28342fe58260d0e71">PlaneBoundedVolumeList</a>&amp; _getFrustumClipVolumes(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* <span class="keyword">const</span> cam) <span class="keyword">const</span>;
<a name="l00368"></a>00368 
<a name="l00370"></a>00370         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> getTypeFlags(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00371"></a>00371 
<a name="l00373"></a>00373         <a class="code" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a> createAnimableValue(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; valueName);
<a name="l00374"></a>00374 
<a name="l00381"></a>00381         <span class="keywordtype">void</span> setCustomShadowCameraSetup(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ShadowCameraSetupPtr</a>&amp; customShadowSetup);
<a name="l00382"></a>00382 
<a name="l00386"></a>00386         <span class="keywordtype">void</span> resetCustomShadowCameraSetup(<span class="keywordtype">void</span>);
<a name="l00387"></a>00387 
<a name="l00389"></a>00389         <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ShadowCameraSetupPtr</a>&amp; getCustomShadowCameraSetup(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00390"></a>00390 
<a name="l00392"></a>00392         <span class="keywordtype">void</span> visitRenderables(<a class="code" href="classOgre_1_1Renderable_1_1Visitor.html" title="Visitor object that can be used to iterate over a collection of Renderable instances abstractly...">Renderable::Visitor</a>* visitor, 
<a name="l00393"></a>00393             <span class="keywordtype">bool</span> debugRenderables = <span class="keyword">false</span>);
<a name="l00394"></a>00394 
<a name="l00403"></a><a class="code" href="classOgre_1_1Light.html#ab33b964677ede81059876de81f65bc3d">00403</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Light.html#ab33b964677ede81059876de81f65bc3d" title="Gets the index at which this light is in the current render.">_getIndexInFrame</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIndexInFrame; }
<a name="l00404"></a><a class="code" href="classOgre_1_1Light.html#a8be55b8ecc3c79532711429fc8a5d36a">00404</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Light.html#a8be55b8ecc3c79532711429fc8a5d36a">_notifyIndexInFrame</a>(<span class="keywordtype">size_t</span> i) { mIndexInFrame = i; }
<a name="l00405"></a>00405         
<a name="l00421"></a>00421         <span class="keywordtype">void</span> setShadowFarDistance(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> distance);
<a name="l00424"></a>00424         <span class="keywordtype">void</span> resetShadowFarDistance(<span class="keywordtype">void</span>);
<a name="l00428"></a>00428         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getShadowFarDistance(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00429"></a>00429         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getShadowFarDistanceSquared(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00430"></a>00430 
<a name="l00435"></a><a class="code" href="classOgre_1_1Light.html#a91a8c7867631ecda45eb934bfaf0aff1">00435</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Light.html#a91a8c7867631ecda45eb934bfaf0aff1" title="Set the near clip plane distance to be used by the shadow camera, if this light casts texture shadows...">setShadowNearClipDistance</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearClip) { mShadowNearClipDist = nearClip; }
<a name="l00436"></a>00436 
<a name="l00442"></a><a class="code" href="classOgre_1_1Light.html#aadfb57f8b9b254dc20a7636ba905202c">00442</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Light.html#aadfb57f8b9b254dc20a7636ba905202c" title="Get the near clip plane distance to be used by the shadow camera, if this light casts texture shadows...">getShadowNearClipDistance</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mShadowNearClipDist; }
<a name="l00443"></a>00443 
<a name="l00447"></a>00447         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> _deriveShadowNearClipDistance(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* maincam) <span class="keyword">const</span>;
<a name="l00448"></a>00448 
<a name="l00456"></a><a class="code" href="classOgre_1_1Light.html#aeb90ddb3515b7e3ac936367e40d49d20">00456</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Light.html#aeb90ddb3515b7e3ac936367e40d49d20" title="Set the far clip plane distance to be used by the shadow camera, if this light casts texture shadows...">setShadowFarClipDistance</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farClip) { mShadowFarClipDist = farClip; }
<a name="l00457"></a>00457 
<a name="l00463"></a><a class="code" href="classOgre_1_1Light.html#a77b768fce165095d36e4fadf11ca89e1">00463</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Light.html#a77b768fce165095d36e4fadf11ca89e1" title="Get the far clip plane distance to be used by the shadow camera, if this light casts texture shadows...">getShadowFarClipDistance</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mShadowFarClipDist; }
<a name="l00464"></a>00464 
<a name="l00468"></a>00468         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> _deriveShadowFarClipDistance(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* maincam) <span class="keyword">const</span>;
<a name="l00469"></a>00469 
<a name="l00471"></a>00471         <span class="keywordtype">void</span> _setCameraRelative(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00472"></a>00472 
<a name="l00488"></a>00488         <span class="keywordtype">void</span> setCustomParameter(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> index, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; value);
<a name="l00489"></a>00489 
<a name="l00494"></a>00494         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; getCustomParameter(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> index) <span class="keyword">const</span>;
<a name="l00495"></a>00495 
<a name="l00518"></a>00518         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateCustomGpuParameter(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> paramIndex, 
<a name="l00519"></a>00519             <span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html" title="Structure recording the use of an automatic parameter.">GpuProgramParameters::AutoConstantEntry</a>&amp; constantEntry, 
<a name="l00520"></a>00520             <a class="code" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a>* params) <span class="keyword">const</span>;
<a name="l00521"></a>00521     <span class="keyword">protected</span>:
<a name="l00523"></a>00523         <span class="keyword">virtual</span> <span class="keywordtype">void</span> update(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00524"></a>00524 
<a name="l00526"></a>00526         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getAnimableDictionaryName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00528"></a>00528         <span class="keywordtype">void</span> initialiseAnimableDictionary(<a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>&amp; vec) <span class="keyword">const</span>;
<a name="l00529"></a>00529 
<a name="l00530"></a><a class="code" href="classOgre_1_1Light.html#afc9d2ccf3f4b9b1285b4b1b8086d8e2f">00530</a>         <a class="code" href="classOgre_1_1Light.html#a4f1dea084d1497c6f49e802ade940dbc" title="Defines the type of light.">LightTypes</a> <a class="code" href="classOgre_1_1Light.html#afc9d2ccf3f4b9b1285b4b1b8086d8e2f">mLightType</a>;
<a name="l00531"></a><a class="code" href="classOgre_1_1Light.html#a5f838a3710d950c2699517f070a86995">00531</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Light.html#a5f838a3710d950c2699517f070a86995">mPosition</a>;
<a name="l00532"></a><a class="code" href="classOgre_1_1Light.html#a6d7d01483a27ce195ce7e242114361a9">00532</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="classOgre_1_1Light.html#a6d7d01483a27ce195ce7e242114361a9">mDiffuse</a>;
<a name="l00533"></a><a class="code" href="classOgre_1_1Light.html#a6d2172419c35c595b76639110311edcf">00533</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="classOgre_1_1Light.html#a6d2172419c35c595b76639110311edcf">mSpecular</a>;
<a name="l00534"></a>00534 
<a name="l00535"></a><a class="code" href="classOgre_1_1Light.html#a3ea988354dde44fb698359dd51ae2fb9">00535</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Light.html#a3ea988354dde44fb698359dd51ae2fb9">mDirection</a>;
<a name="l00536"></a>00536 
<a name="l00537"></a><a class="code" href="classOgre_1_1Light.html#a37346e5d84403c0b87be42b2f2d8772f">00537</a>         <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> <a class="code" href="classOgre_1_1Light.html#a37346e5d84403c0b87be42b2f2d8772f">mSpotOuter</a>;
<a name="l00538"></a><a class="code" href="classOgre_1_1Light.html#accbb6156162f3cedbc5e0ff304532c2b">00538</a>         <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> <a class="code" href="classOgre_1_1Light.html#accbb6156162f3cedbc5e0ff304532c2b">mSpotInner</a>;
<a name="l00539"></a><a class="code" href="classOgre_1_1Light.html#a161e25b6228ba5cf9b2cbb1ff9ea77e8">00539</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Light.html#a161e25b6228ba5cf9b2cbb1ff9ea77e8">mSpotFalloff</a>;
<a name="l00540"></a><a class="code" href="classOgre_1_1Light.html#a32b5f370ef522bd7ec34a07c3ffd8f9d">00540</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Light.html#a32b5f370ef522bd7ec34a07c3ffd8f9d">mSpotNearClip</a>;
<a name="l00541"></a><a class="code" href="classOgre_1_1Light.html#a1da47a9c442d77dd92f1005358370a7e">00541</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Light.html#a1da47a9c442d77dd92f1005358370a7e">mRange</a>;
<a name="l00542"></a><a class="code" href="classOgre_1_1Light.html#a24752d48882af5963f60999354ab33c5">00542</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Light.html#a24752d48882af5963f60999354ab33c5">mAttenuationConst</a>;
<a name="l00543"></a><a class="code" href="classOgre_1_1Light.html#a011f056b28ea82aa6ffc2268ef371660">00543</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Light.html#a011f056b28ea82aa6ffc2268ef371660">mAttenuationLinear</a>;
<a name="l00544"></a><a class="code" href="classOgre_1_1Light.html#a601daee6ce5725c4269f2db10fcdda45">00544</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Light.html#a601daee6ce5725c4269f2db10fcdda45">mAttenuationQuad</a>;
<a name="l00545"></a><a class="code" href="classOgre_1_1Light.html#adc81449ed7c27ba27fb95a9bb667d378">00545</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Light.html#adc81449ed7c27ba27fb95a9bb667d378">mPowerScale</a>;
<a name="l00546"></a><a class="code" href="classOgre_1_1Light.html#ad03882535cf52ab61a3cfb47098990e1">00546</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Light.html#ad03882535cf52ab61a3cfb47098990e1">mIndexInFrame</a>;
<a name="l00547"></a><a class="code" href="classOgre_1_1Light.html#a4df0ec6998cff8d50dc802b85f4dbeb7">00547</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Light.html#a4df0ec6998cff8d50dc802b85f4dbeb7">mOwnShadowFarDist</a>;
<a name="l00548"></a><a class="code" href="classOgre_1_1Light.html#a59803e251979bea7118013968e2c54b0">00548</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Light.html#a59803e251979bea7118013968e2c54b0">mShadowFarDist</a>;
<a name="l00549"></a><a class="code" href="classOgre_1_1Light.html#af377e7227f4f6c8dc0f93ecde14ca119">00549</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Light.html#af377e7227f4f6c8dc0f93ecde14ca119">mShadowFarDistSquared</a>;
<a name="l00550"></a>00550         
<a name="l00551"></a><a class="code" href="classOgre_1_1Light.html#a4f219e8639f4b63d8063125ced05e9f4">00551</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Light.html#a4f219e8639f4b63d8063125ced05e9f4">mShadowNearClipDist</a>;
<a name="l00552"></a><a class="code" href="classOgre_1_1Light.html#a6064c962a009119f5f279ef66854f866">00552</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Light.html#a6064c962a009119f5f279ef66854f866">mShadowFarClipDist</a>;
<a name="l00553"></a>00553 
<a name="l00554"></a>00554 
<a name="l00555"></a><a class="code" href="classOgre_1_1Light.html#a5024f67e7f25fc03f364578a98524df3">00555</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Light.html#a5024f67e7f25fc03f364578a98524df3">mDerivedPosition</a>;
<a name="l00556"></a><a class="code" href="classOgre_1_1Light.html#aa33da09147f64bd9a6af041f1ae29511">00556</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Light.html#aa33da09147f64bd9a6af041f1ae29511">mDerivedDirection</a>;
<a name="l00557"></a>00557         <span class="comment">// Slightly hacky but unless we separate observed light render state from main Light...</span>
<a name="l00558"></a><a class="code" href="classOgre_1_1Light.html#ac0def413b3093c8e5cdbd14167eb89aa">00558</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Light.html#ac0def413b3093c8e5cdbd14167eb89aa">mDerivedCamRelativePosition</a>;
<a name="l00559"></a><a class="code" href="classOgre_1_1Light.html#af6e7ee3456e5c0b4ef3cf06d81feb584">00559</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Light.html#af6e7ee3456e5c0b4ef3cf06d81feb584">mDerivedCamRelativeDirty</a>;
<a name="l00560"></a><a class="code" href="classOgre_1_1Light.html#a0af9de4ab63af10aac4316aeab96e71d">00560</a>         <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* <a class="code" href="classOgre_1_1Light.html#a0af9de4ab63af10aac4316aeab96e71d">mCameraToBeRelativeTo</a>;
<a name="l00561"></a>00561 
<a name="l00563"></a><a class="code" href="classOgre_1_1Light.html#a3fe6a5ae4d4b52207deccc4ce1e52832">00563</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Light.html#a3fe6a5ae4d4b52207deccc4ce1e52832" title="Shared class-level name for Movable type.">msMovableType</a>;
<a name="l00564"></a>00564 
<a name="l00565"></a><a class="code" href="classOgre_1_1Light.html#a1f4faa64483b0ec25059f1e572deadea">00565</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1PlaneBoundedVolume.html" title="Represents a convex volume bounded by planes.">PlaneBoundedVolume</a> <a class="code" href="classOgre_1_1Light.html#a1f4faa64483b0ec25059f1e572deadea">mNearClipVolume</a>;
<a name="l00566"></a><a class="code" href="classOgre_1_1Light.html#afe9e8df56e09c920cf3f9f357ab0914c">00566</a>         <span class="keyword">mutable</span> <a class="code" href="group__Math.html#ga6253a1300d656ba28342fe58260d0e71">PlaneBoundedVolumeList</a> <a class="code" href="classOgre_1_1Light.html#afe9e8df56e09c920cf3f9f357ab0914c">mFrustumClipVolumes</a>;
<a name="l00568"></a><a class="code" href="classOgre_1_1Light.html#a2fe86b96972df91772c4cfa18080a702">00568</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Light.html#a2fe86b96972df91772c4cfa18080a702" title="Is the derived transform dirty?">mDerivedTransformDirty</a>;
<a name="l00569"></a>00569 
<a name="l00571"></a><a class="code" href="classOgre_1_1Light.html#ad621fad7e9875b439bb0e9bde91d6e6b">00571</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1SharedPtr.html">ShadowCameraSetupPtr</a> <a class="code" href="classOgre_1_1Light.html#ad621fad7e9875b439bb0e9bde91d6e6b" title="Pointer to a custom shadow camera setup.">mCustomShadowCameraSetup</a>;
<a name="l00572"></a>00572 
<a name="l00573"></a><a class="code" href="classOgre_1_1Light.html#ac8b08100ac2af172d872a2e23da7634d">00573</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;uint16, Vector4&gt;::type</a> <a class="code" href="classOgre_1_1Light.html#ac8b08100ac2af172d872a2e23da7634d">CustomParameterMap</a>;
<a name="l00575"></a><a class="code" href="classOgre_1_1Light.html#af42c9bfe026188b4083d3382139ed642">00575</a>         <a class="code" href="classOgre_1_1Light.html#ac8b08100ac2af172d872a2e23da7634d">CustomParameterMap</a> <a class="code" href="classOgre_1_1Light.html#af42c9bfe026188b4083d3382139ed642" title="Stores the custom parameters for the light.">mCustomParameters</a>;
<a name="l00576"></a>00576     };
<a name="l00577"></a>00577 
<a name="l00579"></a><a class="code" href="classOgre_1_1LightFactory.html">00579</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1LightFactory.html" title="Factory object for creating Light instances.">LightFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject, and can be registered with Root in order to allow all clients to produce new instances of this object, integrated with the standard Ogre processing.">MovableObjectFactory</a>
<a name="l00580"></a>00580     {
<a name="l00581"></a>00581     <span class="keyword">protected</span>:
<a name="l00582"></a>00582         <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* createInstanceImpl( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* params);
<a name="l00583"></a>00583     <span class="keyword">public</span>:
<a name="l00584"></a><a class="code" href="classOgre_1_1LightFactory.html#a7cce44bd71877c5bc68bce055171380f">00584</a>         <a class="code" href="classOgre_1_1LightFactory.html#a7cce44bd71877c5bc68bce055171380f">LightFactory</a>() {}
<a name="l00585"></a><a class="code" href="classOgre_1_1LightFactory.html#ad4e5a3107760c39b3742113c336bff8d">00585</a>         <a class="code" href="classOgre_1_1LightFactory.html#ad4e5a3107760c39b3742113c336bff8d">~LightFactory</a>() {}
<a name="l00586"></a>00586 
<a name="l00587"></a><a class="code" href="classOgre_1_1LightFactory.html#a5b926946c7150a3eb68c92f31bfde97c">00587</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1LightFactory.html#a5b926946c7150a3eb68c92f31bfde97c">FACTORY_TYPE_NAME</a>;
<a name="l00588"></a>00588 
<a name="l00589"></a>00589         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00590"></a>00590         <span class="keywordtype">void</span> destroyInstance( <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* obj);  
<a name="l00591"></a>00591 
<a name="l00592"></a>00592     };
<a name="l00596"></a>00596 } <span class="comment">// Namespace</span>
<a name="l00597"></a>00597 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
